<!doctype html>
<html>

<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

	<title>ASM Control Flow</title>

	<link rel="icon" type="image/png" href="images/org_symbol.png" />
	<link rel="stylesheet" href="css/reset.css">
	<link rel="stylesheet" href="css/reveal.css">
	<link rel="stylesheet" href="css/theme/league.css" id="theme">

	<!-- Theme used for syntax highlighting of code -->
	<link rel="stylesheet" href="lib/css/monokai.css">

	<!-- Printing and PDF exports -->
	<script>
		var link = document.createElement('link');
		link.rel = 'stylesheet';
		link.type = 'text/css';
		link.href = window.location.search.match(/print-pdf/gi) ? 'css/print/pdf.css' : 'css/print/paper.css';
		document.getElementsByTagName('head')[0].appendChild(link);
	</script>
</head>

<body>
	<!-- UGLY inline CSS but using this div to test Unclassified banner -->
	<!-- <div style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</div> -->
	<div class="reveal">
		<div class="slides">
			<section data-background-image="images/org_symbol.png" data-background-size="13%"
				data-background-position="top 5% left 5%">
				<h1>Assembly Control Flow</h1>
				<h4>90th Cyberspace Operations Squadron</h4>
			</section>
			<section data-background-image="images/org_symbol.png" data-background-size="13%"
				data-background-position="top 5% left 5%">
				<h2>Summary</h2>
				<h3>Assembly Slides are organized by unit</h3>
				<ul>
					<li>Introduction to ASM</li>
					<li>ASM Basic Operations</li>
					<li>ASM Control Flow</li>

				</ul>
				<aside class="notes">
					Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for
					instructor view!!
				</aside>
			</section>

			<!-- FILL WITH SECTIONS (SLIDES) -->
			<section>
				<h2>ASM Control Flow</h2>
				<h2>Overview</h2>
				<ul>
					<li>Flags</li>
					<li>Control Flow</li>
					<li>String Calls</li>
				</ul>
			</section>
			<section>
				<h2>Objectives</h2>
				<ul>
					<li>Use status flags</li>
					<li>Implementy control flow</li>
					<li>Use string instructions and corresponding prefixes</li>
				</ul>
			</section>
			<section>
				<h2>Objectives</h2>
				<a href="../objectives.html" target="_blank">ASM Control Flow Objectives</a>
			</section>


			<section data-background-image="images/org_symbol.png" data-background-size="13%"
				data-background-position="top 5% left 5%">

				<section>
					<h2>Flags</h2>
					<ul>
						<li>rflags - 64 bits</li>
						<li>eflags - 32 bits</li>
						<li>flags - 8 bits</li>
						<li>Zero Flag</li>
						<li>Carry Flag</li>
						<li>Overflow Flag</li>
						<li>Sign Flag</li>
						<li>pushf / popf</li>
						<li>Lab 6</li>
					</ul>
				</section>



				<section>
					<h3>Flags</h3>
					<p style="font-size: 80%;"><em>We'll only use some of them</em></p>
					<img src="../../assets/eflags_clear.png" alt="diagram of eflags" height="400">
					<p style="font-size: 70%;">More information <a
							href="https://revers.engineering/applied-re-accelerated-assembly-p1/">here</a></p>
				</section>

				<section>
					<h2>Zero Flag</h2>
					<p style="font-size:120%;">Set when arithmetic or bitwise operations results in 0</p>
				</section>

				<section>
					<p style="font-size:140%;">Carry Flag</p>
					<p style="font-size:80%;"><em>for unsigned numbers</em></p>

					<ul>
						<p>When more bits needed than specified i.e.</p>
						<li>borrow or carry during add/sub<br>
							beyond allotted bits</li>
						<li>when a bit falls of the end with <em style="color:#f82571;">shr</em> or <em
								style="color:#f82571;">shl</em> </li>

					</ul>

				</section>

				<section>
					<p style="font-size:140%;">Overflow Flag</p>
					<p style="font-size:80%;"><em>for signed numbers</em></p>


					<ul>
						<p>If result different sign than operands i.e. </p>
						<li>adding large positive numbers can produce a negative result due to overflow</li>
						<li>subtracting two numbers exceeding register size (-129 for 8bit)</li>

					</ul>
				</section>

				<section>
					<p style="font-size:140%;">Sign Flag</p>
					<p style="font-size:120%;"> when result is negative</p>

				</section>

				<section>
					<p style="font-size:220%; font-weight:bold"><em>pushf</em> and <em>popf</em></p>
					<p style="font-size:140%;">push and pop flags</p>
					<ul>
						<li><em style="color:#f82571;">pushf</em> - pushes the flag register onto the stack</li>
						<li><em style="color:#f82571;">popf</em> - pops value on top of stack into flags register</li>
					</ul>
				</section>




				<section>
					<p style="font-size:220%; font-weight:bold">pushf / popf</p>
					<div class="sl-block" data-block-type="code">
						<div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none"
							style="z-index: 10;">
							<pre style="font-size: 36px; line-height: 42px;"><code>
pushf       
; flags have been pushed to the stack
; ... do stuff
popf        
; flags have been restored
; that's it
											</code></pre>
						</div>
					</div>
					<p>cf. push<em>fd</em> and pop<em>fd</em></p>
					<p style="font-size: 70%;">See also <a
							href="https://www.quora.com/What-is-POPF-I-can-understand-PUSHF-cause-it-simply-push-flags-but-what-is-POPF-How-does-computer-know-what-is-flag-to-pop-1">here</a>
					</p>
				</section>

				<section>
					<h2>**Complete Performance Lab 6**</h2>
				</section>
			</section>

			<section data-background-image="images/org_symbol.png" data-background-size="13%"
				data-background-position="top 5% left 5%">

				<section>
					<h2>Control Flow</h2>
					<ul>
						<li>global / local labels</li>
						<li>jmp</li>
						<li>call / ret</li>
						<li>cmp</li>
						<li>test</li>
						<li>jcc</li>
						<li>loop</li>
						<li>Lab 7</li>

					</ul>
				</section>


				<section>
					<p style="font-size: 120%;">global / local <em>labels</em></p>
					<p>symbolic names for instructions</p>
					<p>global - can be accessed anywhere </p>
					<p>local - refer to preceding global labels</p>
					<p style="font-size: 70%;"> More examples - available <a
							href="https://www.quora.com/How-Are-Labels-Named-In-Assembly-Language">here</a></p>
				</section>

				<section>
					<p style="font-size:200%; font-weight:bold">global<em style="color:#f82571;">:</em>
					</p>
					<p style="font-size:200%; font-weight:bold"><em style="color:#f82571;">.</em>local:
					</p>
					<div class="sl-block" data-block-type="code">
						<div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none"
							style="z-index: 10;">
							<pre style="font-size: 36px; line-height: 42px;"><code>add_ten_rcx:	add rcx, 10
.local_copy: 	mov rcx, 10

add_five_rcx:	add rcx, 5
.local_copy: 	mov rcx, 5
; local label - notice the '.'
jmp add_ten_rcx.local_copy			</code></pre>
						</div>
					</div>
					<p style="font-size: 70%;"> More examples - available <a
							href="https://www.tortall.net/projects/yasm/manual/html/nasm-local-label.html">here</a></p>
				</section>




				<section>
					<p style="font-size:220%; font-weight:bold">jmp</p>
					<h3>unconditional transfer of execution</h3>
					<div class="sl-block" data-block-type="code">
						<div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none"
							style="z-index: 10;">
							<pre style="font-size: 32px; line-height: 34px;"><code>
.label1:
	xor rcx, rcx
	inc rcx
	jmp .label2
	mov rsp, rcx        
	; never gets executed
.label2:
	shl rcx, 3          
	; execution continues here...</code></pre>
						</div>
					</div>
				</section>




				<section>
					<p style="font-size:220%; font-weight:bold">call / ret</p>
					<ul>
						<li>similar to <em style="color:#f82571;">jmp</em></li>
						<li>equivalent to: </li> <em style="color:#f82571;">push rip</em> then <em
							style="color:#f82571;">jmp somelocation</em></li>
						<li>typically a function call</li>
					</ul>
					<p style="font-size: 70%;"> For more information on <em>rip</em> see <a
							href="https://compas.cs.stonybrook.edu/~nhonarmand/courses/sp17/cse506/ref/assembly.html">here</a>,
						<a href="https://security.stackexchange.com/questions/129499/what-does-eip-stand-for">here</a>,
						and <a href="https://wiki.skullsecurity.org/index.php?title=Registers#eip">here</a></p>
				</section>

				<section>
					<p style="font-size:220%; font-weight:bold">call / ret</p>
					<div class="sl-block" data-block-type="code">
						<div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none"
							style="z-index: 10;">
							<pre style="font-size: 28px; line-height: 32px;"><code>
mov rax, 1
call label1     
; push RIP, jump to label 1
jmp label2
								
label1:
	ror rax, 1
	ret         
	; returns control returns to "jmp label2"
label2:
	mov rax, 2
										</code></pre>
						</div>
					</div>
				</section>


				<section>
					<p style="font-size:220%; font-weight:bold">cmp</p>
					<ul>
						<li>compares two values using subtraction</li>
						<li>sets flags to indicate if values equal</li>
						<li>i.e. same flag values as <em>sub</em>:<br>
							<em>CF, OF, SF, ZF, AF, PF</em></li>
						<li>does <em>not</em> modify values</li>
					</ul>
				</section>

				<section>
					<p style="font-size:220%; font-weight:bold">cmp</p>
					<table>
						<tr>
							<td><em style="color:#f82571;">cmp</em> dst, src</td>
							<td><em>ZF</em></td>
							<td><em>CF</em></td>
						</tr>

						<tr>
							<td>dst = src </td>
							<td>1</td>
							<td>0</td>
						</tr>
						<tr>
							<td>dst < src </td>
							<td>0</td>
							<td>1</td>
						</tr>

						<tr>
							<td>dst > src</td>
							<td>0</td>
							<td>0</td>
						</tr>
					</table>
				</section>


				<section>
					<p style="font-size:220%; font-weight:bold">cmp</p>
					<div class="sl-block" data-block-type="code">
						<div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none"
							style="z-index: 10;">
							<pre style="font-size: 36px; line-height: 42px;"><code>
xor rax, rax
cmp rax, 0      
; rax == 0 - The Zero Flag is now set
										</code></pre>
						</div>
					</div>
				</section>


				<section>
					<p style="font-size:220%; font-weight:bold">test</p>
					<ul>
						<li>compares two values using a bitwise AND</li>
						<li>sets <em>SF, PF, and ZF</em> flags to indicate if values equal</li>
						<li>does <em>not</em> modify values</li>
						<li>often used to test whether a register is 0</li>
					</ul>
				</section>

				<section>
					<p style="font-size:220%; font-weight:bold">test</p>
					<div class="sl-block" data-block-type="code">
						<div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none"
							style="z-index: 10;">
							<pre style="font-size: 36px; line-height: 42px;"><code>mov rax, 1
test rax, rax

; the ZF is set to 0
;because the result isn't 0
		
xor rax, rax
test rax, rax       
; the Zero Flag is now 1
								
										</code></pre>
						</div>
					</div>
				</section>


				<section>
					<p style="font-size:220%; font-weight:bold">jcc</p>
					<ul>
						<li>collection of conditional instructions</li>
						<li>execute based on one or more flags</li>
					</ul>


					<p style="font-size: 70%;">See the <a
							href="https://www.intel.com/content/dam/www/public/us/en/documents/manuals/64-ia-32-architectures-software-developer-vol-1-manual.pdf">Intel
							Manual</a> for more information.
					</p>
				</section>

				<section>
					<p style="font-size:180%; font-weight:bold">jcc</p>
					<table>
						<tr>
							<td><em>operand</em></td>
							<td><em>condition</em></td>
						</tr>
						<tr>
							<td><em style="color:orangered;">je</em></td>
							<td>jump if equal</td>
						</tr>
						<tr>
							<td><em style="color:orangered;">jz</em></td>
							<td>jump if zero</td>
						</tr>
						<tr>
							<td><em style="color:orangered;">jne</em></td>
							<td>jump if not equal</td>
						</tr>
						<tr>
							<td><em style="color:orangered;">jnz</em></td>
							<td>jump if not zero</td>
						</tr>
						<tr>
							<td><em style="color:orangered;">ja</em></td>
							<td>jump if operand above is greater</td>
						</tr>
						<tr>
							<td><em style="color:orangered;">jb</em></td>
							<td>jump if operand below is greater</td>
						</tr>
						<tr>
							<td><em style="color:orangered;">jc</em></td>
							<td>jump if carry</td>
						</tr>
					</table>
				</section>


				<section>
					<p style="font-size:220%; font-weight:bold">jz</p>
					<p>check to see if the result of an operation is 0</p>
					<div class="sl-block" data-block-type="code">
						<div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none"
							style="z-index: 10;">
							<pre style="font-size: 30px; line-height: 32px;"><code>
xor rax, rax
test rax, rax
; Because the zero flag is set, jump to the end
jz .end
mov rsi, rax        
; not executed due to jmp

.end:
	ret </code></pre>
						</div>
					</div>
				</section>

				<section>
					<p style="font-size:220%; font-weight:bold">jnz</p>
					<p>for (i=10; i&gt;0; i--)</p>
					<div class="sl-block" data-block-type="code">
						<div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none"
							style="z-index: 10;">
							<pre style="font-size: 30px; line-height: 32px;"><code>
mov rcx, 10
								
.continue:    
	dec rcx 
	test rcx, rcx   
	jnz .continue   
	; jump to .continue, if rcx not 0
					
ret
</code></pre>
						</div>
					</div>
				</section>

				<section>
					<p style="font-size:220%; font-weight:bold">loop</p>
					<ul>
						<li>A simple macro for: <br><em>dec rcx
								<br>test rcx, rcx
								<br>jnz .some_location</em></li>
						<li>Expects ECX/RCX to be populated with a counter variable</li>
					</ul>
				</section>


				<section>
					<p style="font-size:220%; font-weight:bold">loop</p>
					<p>for (i=10; i&gt;0; i--)</p>
					<div class="sl-block" data-block-type="code">
						<div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none"
							style="z-index: 10;">
							<pre style="font-size: 36px; line-height: 42px;"><code>
mov rcx, 10
								
.continue: 
	loop .continue
					
ret
							</code></pre>
						</div>
					</div>
				</section>

				<section>
					<h2>Questions?</h2>
				</section>

				<section>
					<h2>Reflection</h2>
				</section>

				<section>
					<h2>**Complete Performance Lab 7**</h2>
				</section>
			</section>


			<section data-background-image="images/org_symbol.png" data-background-size="13%"
				data-background-position="top 5% left 5%">
				<section>
					<h2>String Calls</h2>
					<ul>
						<li>(R/E)SI/DI/CX/AX</li>
						<li>String Instructions</li>
						<li>Prefixes</li>
						<li>Lab 8 </li>
					</ul>
				</section>

				<section>
					<p style="font-size:220%; font-weight:bold">rsi, esi</p>
					<p style="font-size:220%; font-weight:bold">rdi, edi</p>
				</section>

				<section>
					<p style="font-size:200%; font-weight:bold">String instructions</p>
					<p>Strings are just sequences of bytes in Assembly</p>
					<p>cf. not looking for '\0' terminator </p>
				</section>

				<section>
					<p style="font-size:220%; font-weight:bold">String Features</p>
					<ul>
						<li><em style="color:#f82571;">rsi</em> (or <em style="color:#f82571;">esi</em>) start of
							'source'</li>
						<li><em style="color:#f82571;">rdi</em> (or <em style="color:#f82571;">edi</em>) start of
							'destination'</li>
						<li><em style="color:#f82571;">rcx</em> (or <em style="color:#f82571;">ecx</em>) holds
							counter
							if
							necessary</li>
						<li><em style="color:#f82571;">rax</em> (or <em style="color:#f82571;">eax</em>) holds value
							to
							evaluate against (if necessary)</li>

					</ul>
					<p style="font-size: 60%;">A review of register names and their uses can be found <a
							href="https://www.tutorialspoint.com/assembly_programming/assembly_registers.htm">here</a>
					</p>
				</section>

				<section>
					<p style="font-size:120%; font-weight:bold">What does it mean that commands are <em>unit
							specific</em>?</p>
					<table>
						<tr>
							<td><em>Command</em></td>
							<td><em>Purpose</em></td>
						</tr>
						<tr>
							<td><em style="color:#f82571;">scas</em></td>
							<td>scan string</td>
						</tr>
						<tr>
							<td><em style="color:#f82571;">scasb</em></td>
							<td>searches for data in <em style="color:orangered;">al</em></td>
						</tr>
						<tr>
							<td><em style="color:#f82571;">scasw</em></td>
							<td>searches for data in <em style="color:orangered;">ax</em></td>
						</tr>
						<tr>
							<td><em style="color:#f82571;">scasq</em></td>
							<td>searches for data in <em style="color:orangered;">rax</em></td>
						</tr>
					</table>

					<p style="font-size: 60%;">Further explanation can be found <a
							href="https://www.tutorialspoint.com/assembly_programming/assembly_scas_instruction.htm">here</a>
						and <a href="https://www.felixcloutier.com/x86/scas:scasb:scasw:scasd">here</a></p>

				</section>

				<section>
					<p style="font-size:220%; font-weight:bold">Common String Instructions</p>
					<table>
						<tr>
							<td><em>Name</em></td>
							<td><em>Commands(unit)</em></td>
							<td><em>Purpose</em></td>
						</tr>
						<tr>
							<td><em>Scan String</em></td>
							<td><em style="color:#f82571;">scas</em>(b/w/d/q)</td>
							<td>scans string at RDI for value in (R/E)AX/AL; increments the pointer</td>
						</tr>
						<tr>
							<td><em>Store String</em></td>
							<td><em style="color:#f82571;">stos</em>(b/w/d/q)</td>
							<td>initializes string at RDI for value in (R/E)AX/AL; increments the pointer</td>
						</tr>
					</table>
				</section>




				<section>
					<p style="font-size:220%; font-weight:bold">Common String Instructions</p>
					<table>
						<tr>
							<td><em>Name</em></td>
							<td><em>Commands(unit)</em></td>
							<td><em>Purpose</em></td>
						</tr>

						<tr>
							<td><em>Load String</em></td>
							<td><em style="color:#f82571;">lods</em>(b/w/d/q)</td>
							<td>copies from RSI to (R/E)AX/AL; increments the pointer</td>
						</tr>
						<tr>
							<td><em>Move String</em></td>
							<td><em style="color:#f82571;">movs</em>(b/w/d/q)</td>
							<td>copies data from rsi to rdi; (in/de)crements (e)si and (e)di</td>
						</tr>

					</table>
				</section>


				<section>
					<h3>Common String Instructions</h3>
					<table>
						<tr>
							<td><em>Name</em></td>
							<td><em>Commands(unit)</em></td>
							<td><em>Purpose</em></td>
						</tr>
						<tr>
							<td><em>Compare String</em></td>
							<td><em style="color:#f82571;">cmps</em>(b/w/d/q)</td>
							<td>compares values at RSI and RDI; increments the pointer; updates RFLAGS (or EFLAGS)
								with
								result</td>
						</tr>
					</table>
				</section>

			</section>

			<section data-background-image="images/org_symbol.png" data-background-size="13%"
				data-background-position="top 5% left 5%">
				<section>
					<p style="font-size: 120%;">Prefixes</p>
					<ul>
						<li>added to instructions</li>
						<li>4 groups of legacy prefixes (based on hex & purpose)</li>
						<li>legacy vs. rex </li>
						<li>use RCX/ECX/etc as termination condition; decrement per instruction</li>
					</ul>
					<p style="font-size: 60%;">Further explanation can be found <a
							href="https://wiki.osdev.org/X86-64_Instruction_Encoding#Legacy_Prefixes">here</a></p>
				</section>

				<section>
					<p style="font-size:220%; font-weight:bold">Example Prefixes</p>
					<ul>
						<li>LOCK</li>
						<li>CS</li>
						<li>XACQUIRE/XRELEASE</li>
						<li>BND/NOBND</li>
						<li>REP, REPE/REPZ, REPNE/REPNZ, </li>
					</ul>
					<p style="font-size: 60%;">Further explanation can be found <a
							href="https://nasm.us/doc/nasmdoc3.html">here</a> as well</p>
				</section>

				<section>
					<p style="font-size:220%; font-weight:bold">Prefixes</p>
					<p>This module focuses on the <em>rep</em> prefixes</p>
					<table>
						<tr>
							<td><em>Command</em></td>
							<td><em>Use</em></td>
						</tr>
						<tr>
							<td><em style="color:#f82571;">rep</em></td>
							<td>repeats <em>rcx</em> times</td>
						</tr>
						<tr>
							<td><em style="color:#f82571;">repne</em></td>
							<td>Repeat while not equal - repeats <em>rcx</em> times or until FLAGS indicate equal
							</td>
						</tr>
						<tr>
							<td><em style="color:#f82571;">repe</em></td>
							<td>Repeat while equal - repeats <em>rcx</em> times or until FLAGS indicate <em>NOT</em>
								equal</td>
						</tr>

					</table>
				</section>

				<section>
					<p style="font-size:220%; font-weight:bold">rep</p>
					<p style="font-size:120%; font-weight:bold">unconditional</p>
					<div class="sl-block" data-block-type="code">
						<div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none"
							style="z-index: 10;">
							<pre style="font-size: 36px; line-height: 42px;"><code>
xor rax, rax            
mov rcx, 20             
mov rdi, _my_string_buf
								
rep stosb               
; Continue to store 0 till rcx is 0
							</code></pre>
						</div>
					</div>

				</section>

				<section>
					<p style="font-size:220%; font-weight:bold">rep</p>
					<p style="font-size:120%; font-weight:bold">conditional</p>
					<div class="sl-block" data-block-type="code">
						<div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none"
							style="z-index: 10;">
							<pre style="font-size: 36px; line-height: 42px;">
								<code>xor rax, rax
mov rcx, 20
; assume string
mov rdi, _my_populated_buf
								
repne scasb         
; continue until a NULL byte
; Subtracting new RCX from initial RCX 
; is the byte count</code></pre>
						</div>
					</div>
				</section>

				<section>
					<p style="font-size:220%; font-weight:bold">The <em>D </em> irection <em>F </em> lag</p>
					<ul>
						<li>Controls direction of buffer traversal with REP* </li>
						<li>If set, clear - or crash likely</li>
						<li><em>cld</em> increment lowest to highest</li>
						<li><em>std</em> decrement highest to lowest</li>
					</ul>
				</section>


				<section>
					<p style="font-size:220%; font-weight:bold">cld / std</p>

					<img src="../../assets/std_cld_example.png" alt="std / cld assembly example">


				</section>

				<section>
					<h2>**Complete Performance Lab 8**</h2>
				</section>
			</section>
			<section data-background-image="images/org_symbol.png" data-background-size="13%"
				data-background-position="top 5% left 5%">

				<section>
					<p style="font-size:160%; font-weight:bold">x86/x64 Calling Conventions</p>
					<ul>
						<li>x86 calling conventions</li>
						<li>stdcall</li>
						<li>cdecl</li>
						<li>fastcall</li>
						<li>thiscall</li>
						<li>Microsoft Calling Conventions</li>
						<li>System V Calling Conventions</li>
						<li>x86-64 calling conventions</li>
						<li>Lab 9</li>
					</ul>
				</section>
				<section>
					<p style="font-size:160%; font-weight:bold">Calling Convention Overview</p>
					<p style="font-size:220%; font-weight:bold">x86</p>
					<uL>
						<li><em>Microsoft</em>: name mangling / name decoration</li>
						<li><em>System V:</em> Posix compliant</li>
						<li>stdcall - developer must deallocate stack</li>
						<li>cdecl - caller deallocates stack</li>
						<li>Differences in implementation for other same-named operands</li>
				</section>

				<section>
					<p style="font-size:220%; font-weight:bold">stdcall</p>
					<ul>
						<li>Indicated to compiler (from C) by _stdcall prefix</li>
						<li>Arguments pushed on the stack (in order from right to left)</li>
						<li>Function called (the <em>callee</em>) cleans up the space allocated</li>
						<li>Name appended with "@X" - X is number of bytes to allocate</li>
					</ul>

				</section>

				<section>
					<p style="font-size:160%; font-weight:bold">stdcall</p>
					<p style="font-size:120%; font-weight:bold">Stack Cleanup</p>
					<img src="../../assets/std_call_0.png" alt="__stdcall example" height="400">
				</section>

				<section>
					<p style="font-size:140%; font-weight:bold">stdcall</p>
					<p style="font-size:120%; font-weight:bold">Accessing Parameters</p>
					<p style="font-size:80%; font-weight:bold">If EBP <em>not</em> pushed to stack</p>
					<img src="../../assets/std_call_1.png" alt="__stdcall example - EBF not on stack" height="400">

				</section>


				<section>
					<p style=" font-size:140%; font-weight:bold">stdcall</p>
					<p style="  font-size:120%; font-weight:bold">Accessing Parameters</p>
					<p style="  font-size:80%; font-weight:bold">If EBP <em>has been</em> pushed to stack
					</p>
					<img src="../../assets/std_call_2.png" alt="__stdcall example - EBF on stack" height="400">

				</section>



				<section>
					<p style="  font-size:220%; font-weight:bold">cdecl</p>
					<ul>
						<li>The System V calling convention</li>
						<li>Parameters passed same as stdcall</li>
						<li>calling function (e.g., caller) responsible for cleanup</li>
						<li>leading underscore _ only name mangling</li>
						<li>callee should <em>ret</em></li>
						<li>caller adds bytes to esp for cleanup</li>
					</ul>
				</section>

				<section>
					<p style="  font-size:220%; font-weight:bold">cdecl</p>
					<table>
						<tr>
							<td style="vertical-align: top;"><img src="../../assets/cdecl_callee.png"
									alt="cdecl callee">
							</td>
							<td><img src="../../assets/cdecl_caller.png" alt="cdecl caller"></td>
						</tr>
					</table>
					<aside class="notes">
						Notice how we don't cleanup the callee
						We do cleanup in caller though after call
						See how the arguments are passed?
					</aside>

				</section>


				<section>
					<p style=" font-size:220%; font-weight:bold">fastcall</p>
					<ul>
						<li>First two arguments (from left to right) passed via ECX and EDX automatically</li>
						<li>Remaining arguments pushed on the stack (<em>right</em> to <em>left</em>)</li>
						<li>Cleanup by callee</li>
						<li>Name mangling like <em>stdcall</em> - additional @ is prepended &rarr; @myfunc@8</li>
					</ul>
				</section>


				<section>
					<p style="  font-size:220%; font-weight:bold">thiscall</p>
					<ul>
						<li>Used for C++ non-static member functions</li>
						<li>Defines <em>this</em> pointer - to access specific class instances</li>
						<li><em>Microsoft</em>- <em>this</em> pointer passed to ECX, other parameters like stdcall
						</li>
						<li><em>System V</em>- like cdecl, but <em>this</em> pointer first argument to function</li>
						<li>C++ name mangling more complex and compiler dependent</li>
					</ul>
				</section>

				<section>
					<p style="font-size:220%; font-weight:bold">Calling Convention Overview</p>
					<p style="font-size:220%; font-weight:bold">x86_64</p>
					<ul>
						<li><em>thiscall</em> both x64 conventions pass <em>this</em>pointer as implicit first
							argument
							<br>(as with System V x86)</li>
						<li>Both (like <em>_fastcall</em>) pass arguments in (platform dependent) registers</li>
					</ul>

				</section>

				<section>
					<p style="font-size:220%; font-weight:bold">Microsoft x64 Calling Convention</p>
					<ul>
						<li>First 4 parameters passed to RCX, RDX, R8, R9</li>
						<li>Floating point values passed to SIMD (e.g. XMM0-3)</li>
						<li>Remaining values added to stack</li>
						<li>Caller's responsibility to clean up (like <em>_cdecl</em>)</li>
					</ul>
				</section>

				<section>
					<p style="font-size:140%; font-weight:bold"><em>Shadow Space</em></p>
					<ul>
						<li>x64 calling conventions require stack allocation for passed variables</li>
						<li>allows function to immediately spill registers</li>
						<li>Windows API requires space be allocated for 4 registers (regardless of parameter count)
						</li>
						<li>Any arguments -beyond 4- are added to the stack
							<ul>
								<li>as if all parameters had been passed to the stack</li>
								<li>i.e. parameter 5 would begin at [rsp + 0x20]</li>
							</ul>
						</li>
						<li>Caller must create the stack allocation for passed variables</li>
					</ul>
				</section>

				<section>
					<p style=" font-size:140%; font-weight:bold"><em>Microsoft x64 Calling
							Convention</em></p>
					<p style="font-size:120%; font-weight:bold">No Parameters</p>
					<img height="400" src="../../assets/x64_noparam.png" alt="x64 calling convention - no parameters">

				</section>

				<section>
					<p style=" font-size:140%; font-weight:bold"><em>Microsoft x64 Calling
							Convention</em></p>
					<p style="font-size:120%; font-weight:bold"> <em>5</em> (or more) Parameters</p>
					<img height="400" src="../../assets/x64_5param.png" alt="x64 calling convention - 5 parameters">
				</section>

				<section>
					<p style="  font-size:140%; font-weight:bold"><em>System V</em> x64 Calling Convention
					</p>
					<ul>
						<li>More values are passed to registers than Microsoft (6v4)</li>
						<li>First 6 arguments passed via RDI, RSI, RDX, RCX, R8, and R9</li>
						<li>Floating point arguments go to SIMD(XMM0-7)</li>
						<li>Additional arguments pushed onto the stack</li>
						<li>Shadow space not required, but stack must remain 16-byte aligned</li>
						<li>Red zone optimization - stack space for leaf functions</li>
					</ul>

				</section>

				<section>
					<p style="color:#cc0909;  font-size:140%; font-weight:bold">The <em>Red Zone</em> Optimization
					</p>
					<ul>
						<li>Use of 128 bytes below RSP without modifying stack pointer</li>
						<li>Further function calls <em>will clobber</em> space</li>
						<li>i.e., Red Zone most suitable for leaf functions </li>
					</ul>
					<aside class="notes">
						leaf functions - functions that do not call other functions
					</aside>

				</section>

				<section>
					<p style=" font-size:140%; font-weight:bold"><em>System V</em> x64 Example
					</p>


					<div class="sl-block" data-block-type="code">
						<div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none"
							style="z-index: 10;">
							<pre style="font-size: 36px; line-height: 42px;">
				<code>extern strlen       

mystring db "this is a string", 0x00    
;  ensure NULL termination!     ^^^^

call_strlen:
	mov rdi, mystring
	call strlen
	ret
</code></pre>
						</div>
					</div>
				</section>

				<section>
					<p style="font-size: 120%;">Return Values</p>
					<ul>
						<li>Usually <em>rax</em></li>
						<li>less than 32 bits - <em>eax</em></li>
						<li>greater that 128 bits - across <em>rax:rdx</em></li>
						<li>floating point - <em>XMM0, XMM1</em></li>
					</ul>
					<p style="font-size: 80%;">For further disambiguation of return values see <a
							href="https://en.wikipedia.org/wiki/X86_calling_conventions">here</a></p>
				</section>

				<section>
					<p><em>Register Preservation</em></p>
					<p style=" font-size:120%; font-weight:bold"><em>x86</em></p>
					<ul>
						<li>Volatile: EAX, ECX, and EDX don't need to be saved</li>
						<li>Other registers must be </li>
						<li>
							<ul>This means:
								<li>Caller presumes <em>volatile registers are destroyed</em> across a call</li>
								<li>Nonvolatile registers must be saved by caller if used</li>
								<li> Compiler automatically pushes onto caller's stack frame to preserve
									non-volatile registers</li>
							</ul>
						</li>
					</ul>

				</section>


				<section>
					<p style="font-size:140%; font-weight:bold"><em>x86</em></p>
					<ul>
						<ul><em>Windows</em>
							<li>Volatile Registers,
								i.e. RAX, RCX, RDX, R8, R9, R10, R11, XMMO-3 and 5, don't need to be reserved
							</li>
							<li>Other registers must be preserved by the callee</li>

						</ul>

						<ul><em>System V</em>
							<li>Most registers are volatile - need to be preserved by caller</li>
							<li>Exceptions: RBP, RBX, and R12-15 are non-volatile i.e. must be preserved by callee
							</li>
						</ul>

					</ul>
				</section>

				<section>
					<h2>Questions?</h2>
				</section>

				<section>
					<h2>Complete Performance Lab 9</h2>
				</section>

			</section>
			<section data-background-image="images/org_symbol.png" data-background-size="13%"
				data-background-position="top 5% left 5%">
				<h2>Conclusion</h2>
				<ul>
					<li>What are examples of control flow in Assembly? </li>
					<li>e.g. what are examples of uncoditional control flow in Assembly? </li>
					<li>e.g. what are examples of conditional control flow in Assembly? </li>
					<li>How are flags used / set in Assembly?</li>

				</ul>
			</section>


			<section data-background-image="images/org_symbol.png" data-background-size="13%"
				data-background-position="top 5% left 5%">
				<h2>Conclusion</h2>
				<ul>

					<li>What are Assembly Calling Conventions?</li>
					<li>What are differences between x86 and x64?</li>
					<li>What are differences between MS and SysV?</li>

				</ul>
			</section>

			<section data-background-image="images/org_symbol.png" data-background-size="13%"
				data-background-position="top 5% left 5%">
				<h2>Questions?</h2>
			</section>
		</div>
	</div>
	<!-- This footer doesn't work. Need to play with CSS -->
	<!-- <footer style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</footer> -->

	<!-- DO NOT TOUCH -->
	<script src="js/reveal.js"></script>

	<script>
		Reveal.initialize({
			slideNumber: true,
			hash: true,
			menu: {
				side: 'left',
				width: 'normal',
				numbers: true,
				titleSelector: 'h1, h2, h3, h4, h5, h6',
				useTextContentForMissingTitles: false,
				hideMissingTitles: false,
				markers: true,
				custom: false,
				themes: true,
				themesPath: 'css/theme/',
				transitions: true,
				openButton: true,
				openSlideNumber: true,
				keyboard: true,
				sticky: true,
				autoOpen: true,
				delayInit: false,
				openOnInit: false,
				loadIcons: true
			},
			dependencies: [
				{ src: 'plugin/markdown/marked.js' },
				{ src: 'plugin/markdown/markdown.js' },
				{ src: 'plugin/highlight/highlight.js' },
				{ src: 'plugin/notes/notes.js', async: true },
				{ src: 'plugin/reveal.js-menu/menu.js' }
			]
		});
		Reveal.configure({ slideNumber: true })
	</script>
</body>

</html>